


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 1D REAL global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_1D_R

	REAL, pointer ::  arr (:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_1D_R), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_1D_R


public array_descriptor_1D_R


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 1D REAL 
!! registered arrays.
!!
type (array_descriptor_1D_R), pointer :: &
				Arr_List_1D_R

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_1D_R)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 2D REAL global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_2D_R

	REAL, pointer ::  arr (:,:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_2D_R), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_2D_R


public array_descriptor_2D_R


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 2D REAL 
!! registered arrays.
!!
type (array_descriptor_2D_R), pointer :: &
				Arr_List_2D_R

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_2D_R)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 3D REAL global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_3D_R

	REAL, pointer ::  arr (:,:,:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_3D_R), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_3D_R


public array_descriptor_3D_R


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 3D REAL 
!! registered arrays.
!!
type (array_descriptor_3D_R), pointer :: &
				Arr_List_3D_R

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_3D_R)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 4D REAL global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_4D_R

	REAL, pointer ::  arr (:,:,:,:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_4D_R), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_4D_R


public array_descriptor_4D_R


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 4D REAL 
!! registered arrays.
!!
type (array_descriptor_4D_R), pointer :: &
				Arr_List_4D_R

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_4D_R)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 1D DOUBLE PRECISION global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_1D_D

	DOUBLE PRECISION, pointer ::  arr (:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_1D_D), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_1D_D


public array_descriptor_1D_D


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 1D DOUBLE PRECISION 
!! registered arrays.
!!
type (array_descriptor_1D_D), pointer :: &
				Arr_List_1D_D

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_1D_D)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 2D DOUBLE PRECISION global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_2D_D

	DOUBLE PRECISION, pointer ::  arr (:,:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_2D_D), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_2D_D


public array_descriptor_2D_D


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 2D DOUBLE PRECISION 
!! registered arrays.
!!
type (array_descriptor_2D_D), pointer :: &
				Arr_List_2D_D

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_2D_D)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 3D DOUBLE PRECISION global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_3D_D

	DOUBLE PRECISION, pointer ::  arr (:,:,:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_3D_D), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_3D_D


public array_descriptor_3D_D


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 3D DOUBLE PRECISION 
!! registered arrays.
!!
type (array_descriptor_3D_D), pointer :: &
				Arr_List_3D_D

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_3D_D)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 4D DOUBLE PRECISION global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_4D_D

	DOUBLE PRECISION, pointer ::  arr (:,:,:,:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_4D_D), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_4D_D


public array_descriptor_4D_D


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 4D DOUBLE PRECISION 
!! registered arrays.
!!
type (array_descriptor_4D_D), pointer :: &
				Arr_List_4D_D

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_4D_D)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 1D COMPLEX global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_1D_C

	COMPLEX, pointer ::  arr (:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_1D_C), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_1D_C


public array_descriptor_1D_C


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 1D COMPLEX 
!! registered arrays.
!!
type (array_descriptor_1D_C), pointer :: &
				Arr_List_1D_C

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_1D_C)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 2D COMPLEX global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_2D_C

	COMPLEX, pointer ::  arr (:,:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_2D_C), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_2D_C


public array_descriptor_2D_C


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 2D COMPLEX 
!! registered arrays.
!!
type (array_descriptor_2D_C), pointer :: &
				Arr_List_2D_C

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_2D_C)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 3D COMPLEX global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_3D_C

	COMPLEX, pointer ::  arr (:,:,:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_3D_C), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_3D_C


public array_descriptor_3D_C


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 3D COMPLEX 
!! registered arrays.
!!
type (array_descriptor_3D_C), pointer :: &
				Arr_List_3D_C

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_3D_C)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 4D COMPLEX global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_4D_C

	COMPLEX, pointer ::  arr (:,:,:,:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_4D_C), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_4D_C


public array_descriptor_4D_C


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 4D COMPLEX 
!! registered arrays.
!!
type (array_descriptor_4D_C), pointer :: &
				Arr_List_4D_C

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_4D_C)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 1D INTEGER global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_1D_I

	INTEGER, pointer ::  arr (:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_1D_I), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_1D_I


public array_descriptor_1D_I


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 1D INTEGER 
!! registered arrays.
!!
type (array_descriptor_1D_I), pointer :: &
				Arr_List_1D_I

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_1D_I)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 2D INTEGER global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_2D_I

	INTEGER, pointer ::  arr (:,:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_2D_I), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_2D_I


public array_descriptor_2D_I


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 2D INTEGER 
!! registered arrays.
!!
type (array_descriptor_2D_I), pointer :: &
				Arr_List_2D_I

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_2D_I)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 3D INTEGER global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_3D_I

	INTEGER, pointer ::  arr (:,:,:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_3D_I), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_3D_I


public array_descriptor_3D_I


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 3D INTEGER 
!! registered arrays.
!!
type (array_descriptor_3D_I), pointer :: &
				Arr_List_3D_I

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_3D_I)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 4D INTEGER global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_4D_I

	INTEGER, pointer ::  arr (:,:,:,:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_4D_I), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_4D_I


public array_descriptor_4D_I


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 4D INTEGER 
!! registered arrays.
!!
type (array_descriptor_4D_I), pointer :: &
				Arr_List_4D_I

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_4D_I)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 1D LOGICAL global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_1D_L

	LOGICAL, pointer ::  arr (:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_1D_L), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_1D_L


public array_descriptor_1D_L


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 1D LOGICAL 
!! registered arrays.
!!
type (array_descriptor_1D_L), pointer :: &
				Arr_List_1D_L

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_1D_L)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 2D LOGICAL global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_2D_L

	LOGICAL, pointer ::  arr (:,:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_2D_L), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_2D_L


public array_descriptor_2D_L


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 2D LOGICAL 
!! registered arrays.
!!
type (array_descriptor_2D_L), pointer :: &
				Arr_List_2D_L

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_2D_L)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 3D LOGICAL global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_3D_L

	LOGICAL, pointer ::  arr (:,:,:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_3D_L), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_3D_L


public array_descriptor_3D_L


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 3D LOGICAL 
!! registered arrays.
!!
type (array_descriptor_3D_L), pointer :: &
				Arr_List_3D_L

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_3D_L)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!








!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! Here is the data type for the linked list node that describes
!! a 4D LOGICAL global array.  It describes how a global
!! array is distributed over the processor array.
!!


type array_descriptor_4D_L

	LOGICAL, pointer ::  arr (:,:,:,:)	!! Pointer to the local
						!! array storage

	type (array_distribution), pointer :: distribution  
						!! Describes the distribution
						!! of the global array over the
						!! array of processes.

	type (array_descriptor_4D_L), &
		pointer :: next
						!! The next element in the 
						!! linked list.

end type array_descriptor_4D_L


public array_descriptor_4D_L


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!
!! This is the head of the linked list of 4D LOGICAL 
!! registered arrays.
!!
type (array_descriptor_4D_L), pointer :: &
				Arr_List_4D_L

!!At initialization NEED TO :
!!  NULLIFY (Arr_List_4D_L)


!!
!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!





