
	module dp_internal

	use dp_public_constants

	implicit none

!IBM* SOURCEFORM (FIXED)
        include 'mpif.h'
!IBM* SOURCEFORM (FREE(F90))




!	Internal data items:

	!! integer, parameter :: DP_MAX_DIMS = 4
	integer, parameter :: DP_MAX_MV_BLOCKS = 16  ! 2**DP_MAX_DIMS

	logical :: dp_initialized = .FALSE.
	logical :: dp_mpi_initialized = .FALSE.
	logical :: dp_serial_run = .FALSE.

	integer :: dp_comm_cart = MPI_COMM_NULL
	integer :: dp_num_procs, dp_rank

	integer dp_coords(DP_MAX_DIMS)
	integer dp_proc_arr_size(DP_MAX_DIMS)

        integer dp_cshift_ierr
        integer dp_eoshift_ierr

        integer, parameter :: dp_maxproc = 64   ! maximum number of processors
        

!!! START RANDOM NUMBER GENERATOR
!   Stuff for random number generator; this will work for a machine 
!   size up to 64 (one can always hope...)
        integer dp_seeds (0: dp_maxproc)

!      Load data array in case user forgets to initialize.
!      This array is the result of calling UNI 100000 times
!         with ISEED=305 and K=64.
       real dp_u_array (1:17)  
       real*4, parameter  ::  dp_uni_denom = 16777216.0
       real*4, parameter  ::  dp_uni_csave = 362436.0/dp_uni_denom
       real*4, parameter  ::  dp_uni_cd    = 7654321.0/dp_uni_denom
       real*4, parameter  ::  dp_uni_cm    = 16777213.0/dp_uni_denom

      real*4  dp_uni_c 
      integer dp_uni_i 
      integer dp_uni_j
      

!!! END RANDOM NUMBER GENERATOR


!!! Some parameters used in the IO routines

	integer, parameter :: DP_WRITE_NEXT_ARR_SEGMENT = 1,  &
		      		DP_REQUEST_ARR_COL = 2,         &
		      		DP_ARR_COL = 3

	integer, parameter :: DP_DOUBLE_PRECISION_SIZE = 8

!!! END of stuff for IO routines




!!! Some error conditions

	!! integer, parameter :: DP_SUCCESS = 0
	!! integer, parameter :: DP_NOT_INITIALIZED = -1
	!! integer, parameter :: DP_INCONSISTENT_ARRAY_SIZE = -2
	!! integer, parameter :: DP_BAD_NUM_PROCS = -3
	!! integer, parameter :: DP_BAD_PROC_NDIMS = -4
	!! integer, parameter :: DP_BAD_CALL_SEQUENCE = -4


!!! 

	end module dp_internal

