
	module dp_reduce_arith

	use DP_INTERNAL

	implicit none

	private



!   These are the public routines



		public dp_sum_1D_R 
		public dp_product_1D_R 
		public dp_dot_product_1D_R 
		public dp_sum_2D_R 
		public dp_product_2D_R 
		public dp_dot_product_2D_R 
		public dp_sum_3D_R 
		public dp_product_3D_R 
		public dp_dot_product_3D_R 
		public dp_sum_4D_R 
		public dp_product_4D_R 
		public dp_dot_product_4D_R 

#if 0
		public dp_sum_1D_R4 
		public dp_product_1D_R4 
		public dp_dot_product_1D_R4 
		public dp_sum_2D_R4 
		public dp_product_2D_R4 
		public dp_dot_product_2D_R4 
		public dp_sum_3D_R4 
		public dp_product_3D_R4 
		public dp_dot_product_3D_R4 
		public dp_sum_4D_R4 
		public dp_product_4D_R4 
		public dp_dot_product_4D_R4 
		public dp_sum_1D_R8 
		public dp_product_1D_R8 
		public dp_dot_product_1D_R8 
		public dp_sum_2D_R8 
		public dp_product_2D_R8 
		public dp_dot_product_2D_R8 
		public dp_sum_3D_R8 
		public dp_product_3D_R8 
		public dp_dot_product_3D_R8 
		public dp_sum_4D_R8 
		public dp_product_4D_R8 
		public dp_dot_product_4D_R8 
		public dp_sum_1D_R16 
		public dp_product_1D_R16 
		public dp_dot_product_1D_R16 
		public dp_sum_2D_R16 
		public dp_product_2D_R16 
		public dp_dot_product_2D_R16 
		public dp_sum_3D_R16 
		public dp_product_3D_R16 
		public dp_dot_product_3D_R16 
		public dp_sum_4D_R16 
		public dp_product_4D_R16 
		public dp_dot_product_4D_R16 
#endif

		public dp_sum_1D_D 
		public dp_product_1D_D 
		public dp_dot_product_1D_D 
		public dp_sum_2D_D 
		public dp_product_2D_D 
		public dp_dot_product_2D_D 
		public dp_sum_3D_D 
		public dp_product_3D_D 
		public dp_dot_product_3D_D 
		public dp_sum_4D_D 
		public dp_product_4D_D 
		public dp_dot_product_4D_D 
		public dp_sum_1D_C 
		public dp_product_1D_C 
		public dp_dot_product_1D_C 
		public dp_sum_2D_C 
		public dp_product_2D_C 
		public dp_dot_product_2D_C 
		public dp_sum_3D_C 
		public dp_product_3D_C 
		public dp_dot_product_3D_C 
		public dp_sum_4D_C 
		public dp_product_4D_C 
		public dp_dot_product_4D_C 

#if 0
		public dp_sum_1D_C8 
		public dp_product_1D_C8 
		public dp_dot_product_1D_C8 
		public dp_sum_2D_C8 
		public dp_product_2D_C8 
		public dp_dot_product_2D_C8 
		public dp_sum_3D_C8 
		public dp_product_3D_C8 
		public dp_dot_product_3D_C8 
		public dp_sum_4D_C8 
		public dp_product_4D_C8 
		public dp_dot_product_4D_C8 
		public dp_sum_1D_C16 
		public dp_product_1D_C16 
		public dp_dot_product_1D_C16 
		public dp_sum_2D_C16 
		public dp_product_2D_C16 
		public dp_dot_product_2D_C16 
		public dp_sum_3D_C16 
		public dp_product_3D_C16 
		public dp_dot_product_3D_C16 
		public dp_sum_4D_C16 
		public dp_product_4D_C16 
		public dp_dot_product_4D_C16 
		public dp_sum_1D_C32 
		public dp_product_1D_C32 
		public dp_dot_product_1D_C32 
		public dp_sum_2D_C32 
		public dp_product_2D_C32 
		public dp_dot_product_2D_C32 
		public dp_sum_3D_C32 
		public dp_product_3D_C32 
		public dp_dot_product_3D_C32 
		public dp_sum_4D_C32 
		public dp_product_4D_C32 
		public dp_dot_product_4D_C32 
#endif

		public dp_sum_1D_I 
		public dp_product_1D_I 
		public dp_dot_product_1D_I 
		public dp_sum_2D_I 
		public dp_product_2D_I 
		public dp_dot_product_2D_I 
		public dp_sum_3D_I 
		public dp_product_3D_I 
		public dp_dot_product_3D_I 
		public dp_sum_4D_I 
		public dp_product_4D_I 
		public dp_dot_product_4D_I 

#if 0
		public dp_sum_1D_I1 
		public dp_product_1D_I1 
		public dp_dot_product_1D_I1 
		public dp_sum_2D_I1 
		public dp_product_2D_I1 
		public dp_dot_product_2D_I1 
		public dp_sum_3D_I1 
		public dp_product_3D_I1 
		public dp_dot_product_3D_I1 
		public dp_sum_4D_I1 
		public dp_product_4D_I1 
		public dp_dot_product_4D_I1 
		public dp_sum_1D_I2 
		public dp_product_1D_I2 
		public dp_dot_product_1D_I2 
		public dp_sum_2D_I2 
		public dp_product_2D_I2 
		public dp_dot_product_2D_I2 
		public dp_sum_3D_I2 
		public dp_product_3D_I2 
		public dp_dot_product_3D_I2 
		public dp_sum_4D_I2 
		public dp_product_4D_I2 
		public dp_dot_product_4D_I2 
		public dp_sum_1D_I4 
		public dp_product_1D_I4 
		public dp_dot_product_1D_I4 
		public dp_sum_2D_I4 
		public dp_product_2D_I4 
		public dp_dot_product_2D_I4 
		public dp_sum_3D_I4 
		public dp_product_3D_I4 
		public dp_dot_product_3D_I4 
		public dp_sum_4D_I4 
		public dp_product_4D_I4 
		public dp_dot_product_4D_I4 
#endif


CONTAINS

include 'dp_reduce_arith.h'


	end module dp_reduce_arith

