





!		module procedure dp_sum_1D_R 
!		module procedure dp_product_1D_R 
!		module procedure dp_dot_product_1D_R 

!		public dp_sum_1D_R 
!		public dp_product_1D_R 
!		public dp_dot_product_1D_R 

FUNCTION dp_sum_1D_R (arr, mask) RESULT (reduction)
REAL reduction
REAL arr (0:)
logical, intent(IN), OPTIONAL :: mask (0:)

	REAL partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (arr, mask=mask)

	else

		partial = SUM (arr, mask=mask)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_REAL, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_sum_1D_R 

FUNCTION dp_product_1D_R (arr, mask) RESULT (reduction)
REAL reduction
REAL arr (0:)
logical, intent(IN), OPTIONAL :: mask (0:)

	REAL partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = PRODUCT (arr, mask=mask)

	else

		partial = PRODUCT (arr, mask=mask)


		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_REAL, &
					MPI_PROD, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_product_1D_R 



FUNCTION dp_dot_product_1D_R (a, b) RESULT (reduction)
REAL reduction
REAL , intent(IN) :: a (0:)
REAL , intent(IN) :: b (0:)

	REAL partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (a*b)

	else

		partial = SUM (a*b)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_REAL, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_dot_product_1D_R 








!		module procedure dp_sum_2D_R 
!		module procedure dp_product_2D_R 
!		module procedure dp_dot_product_2D_R 

!		public dp_sum_2D_R 
!		public dp_product_2D_R 
!		public dp_dot_product_2D_R 

FUNCTION dp_sum_2D_R (arr, mask) RESULT (reduction)
REAL reduction
REAL arr (0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:)

	REAL partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (arr, mask=mask)

	else

		partial = SUM (arr, mask=mask)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_REAL, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_sum_2D_R 

FUNCTION dp_product_2D_R (arr, mask) RESULT (reduction)
REAL reduction
REAL arr (0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:)

	REAL partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = PRODUCT (arr, mask=mask)

	else

		partial = PRODUCT (arr, mask=mask)


		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_REAL, &
					MPI_PROD, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_product_2D_R 



FUNCTION dp_dot_product_2D_R (a, b) RESULT (reduction)
REAL reduction
REAL , intent(IN) :: a (0:,0:)
REAL , intent(IN) :: b (0:,0:)

	REAL partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (a*b)

	else

		partial = SUM (a*b)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_REAL, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_dot_product_2D_R 








!		module procedure dp_sum_3D_R 
!		module procedure dp_product_3D_R 
!		module procedure dp_dot_product_3D_R 

!		public dp_sum_3D_R 
!		public dp_product_3D_R 
!		public dp_dot_product_3D_R 

FUNCTION dp_sum_3D_R (arr, mask) RESULT (reduction)
REAL reduction
REAL arr (0:,0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:,0:)

	REAL partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (arr, mask=mask)

	else

		partial = SUM (arr, mask=mask)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_REAL, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_sum_3D_R 

FUNCTION dp_product_3D_R (arr, mask) RESULT (reduction)
REAL reduction
REAL arr (0:,0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:,0:)

	REAL partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = PRODUCT (arr, mask=mask)

	else

		partial = PRODUCT (arr, mask=mask)


		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_REAL, &
					MPI_PROD, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_product_3D_R 



FUNCTION dp_dot_product_3D_R (a, b) RESULT (reduction)
REAL reduction
REAL , intent(IN) :: a (0:,0:,0:)
REAL , intent(IN) :: b (0:,0:,0:)

	REAL partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (a*b)

	else

		partial = SUM (a*b)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_REAL, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_dot_product_3D_R 








!		module procedure dp_sum_4D_R 
!		module procedure dp_product_4D_R 
!		module procedure dp_dot_product_4D_R 

!		public dp_sum_4D_R 
!		public dp_product_4D_R 
!		public dp_dot_product_4D_R 

FUNCTION dp_sum_4D_R (arr, mask) RESULT (reduction)
REAL reduction
REAL arr (0:,0:,0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:,0:,0:)

	REAL partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (arr, mask=mask)

	else

		partial = SUM (arr, mask=mask)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_REAL, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_sum_4D_R 

FUNCTION dp_product_4D_R (arr, mask) RESULT (reduction)
REAL reduction
REAL arr (0:,0:,0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:,0:,0:)

	REAL partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = PRODUCT (arr, mask=mask)

	else

		partial = PRODUCT (arr, mask=mask)


		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_REAL, &
					MPI_PROD, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_product_4D_R 



FUNCTION dp_dot_product_4D_R (a, b) RESULT (reduction)
REAL reduction
REAL , intent(IN) :: a (0:,0:,0:,0:)
REAL , intent(IN) :: b (0:,0:,0:,0:)

	REAL partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (a*b)

	else

		partial = SUM (a*b)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_REAL, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_dot_product_4D_R 








!		module procedure dp_sum_1D_D 
!		module procedure dp_product_1D_D 
!		module procedure dp_dot_product_1D_D 

!		public dp_sum_1D_D 
!		public dp_product_1D_D 
!		public dp_dot_product_1D_D 

FUNCTION dp_sum_1D_D (arr, mask) RESULT (reduction)
DOUBLE PRECISION reduction
DOUBLE PRECISION arr (0:)
logical, intent(IN), OPTIONAL :: mask (0:)

	DOUBLE PRECISION partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (arr, mask=mask)

	else

		partial = SUM (arr, mask=mask)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_DOUBLE_PRECISION, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_sum_1D_D 

FUNCTION dp_product_1D_D (arr, mask) RESULT (reduction)
DOUBLE PRECISION reduction
DOUBLE PRECISION arr (0:)
logical, intent(IN), OPTIONAL :: mask (0:)

	DOUBLE PRECISION partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = PRODUCT (arr, mask=mask)

	else

		partial = PRODUCT (arr, mask=mask)


		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_DOUBLE_PRECISION, &
					MPI_PROD, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_product_1D_D 



FUNCTION dp_dot_product_1D_D (a, b) RESULT (reduction)
DOUBLE PRECISION reduction
DOUBLE PRECISION , intent(IN) :: a (0:)
DOUBLE PRECISION , intent(IN) :: b (0:)

	DOUBLE PRECISION partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (a*b)

	else

		partial = SUM (a*b)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_DOUBLE_PRECISION, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_dot_product_1D_D 








!		module procedure dp_sum_2D_D 
!		module procedure dp_product_2D_D 
!		module procedure dp_dot_product_2D_D 

!		public dp_sum_2D_D 
!		public dp_product_2D_D 
!		public dp_dot_product_2D_D 

FUNCTION dp_sum_2D_D (arr, mask) RESULT (reduction)
DOUBLE PRECISION reduction
DOUBLE PRECISION arr (0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:)

	DOUBLE PRECISION partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (arr, mask=mask)

	else

		partial = SUM (arr, mask=mask)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_DOUBLE_PRECISION, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_sum_2D_D 

FUNCTION dp_product_2D_D (arr, mask) RESULT (reduction)
DOUBLE PRECISION reduction
DOUBLE PRECISION arr (0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:)

	DOUBLE PRECISION partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = PRODUCT (arr, mask=mask)

	else

		partial = PRODUCT (arr, mask=mask)


		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_DOUBLE_PRECISION, &
					MPI_PROD, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_product_2D_D 



FUNCTION dp_dot_product_2D_D (a, b) RESULT (reduction)
DOUBLE PRECISION reduction
DOUBLE PRECISION , intent(IN) :: a (0:,0:)
DOUBLE PRECISION , intent(IN) :: b (0:,0:)

	DOUBLE PRECISION partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (a*b)

	else

		partial = SUM (a*b)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_DOUBLE_PRECISION, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_dot_product_2D_D 








!		module procedure dp_sum_3D_D 
!		module procedure dp_product_3D_D 
!		module procedure dp_dot_product_3D_D 

!		public dp_sum_3D_D 
!		public dp_product_3D_D 
!		public dp_dot_product_3D_D 

FUNCTION dp_sum_3D_D (arr, mask) RESULT (reduction)
DOUBLE PRECISION reduction
DOUBLE PRECISION arr (0:,0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:,0:)

	DOUBLE PRECISION partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (arr, mask=mask)

	else

		partial = SUM (arr, mask=mask)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_DOUBLE_PRECISION, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_sum_3D_D 

FUNCTION dp_product_3D_D (arr, mask) RESULT (reduction)
DOUBLE PRECISION reduction
DOUBLE PRECISION arr (0:,0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:,0:)

	DOUBLE PRECISION partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = PRODUCT (arr, mask=mask)

	else

		partial = PRODUCT (arr, mask=mask)


		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_DOUBLE_PRECISION, &
					MPI_PROD, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_product_3D_D 



FUNCTION dp_dot_product_3D_D (a, b) RESULT (reduction)
DOUBLE PRECISION reduction
DOUBLE PRECISION , intent(IN) :: a (0:,0:,0:)
DOUBLE PRECISION , intent(IN) :: b (0:,0:,0:)

	DOUBLE PRECISION partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (a*b)

	else

		partial = SUM (a*b)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_DOUBLE_PRECISION, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_dot_product_3D_D 








!		module procedure dp_sum_4D_D 
!		module procedure dp_product_4D_D 
!		module procedure dp_dot_product_4D_D 

!		public dp_sum_4D_D 
!		public dp_product_4D_D 
!		public dp_dot_product_4D_D 

FUNCTION dp_sum_4D_D (arr, mask) RESULT (reduction)
DOUBLE PRECISION reduction
DOUBLE PRECISION arr (0:,0:,0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:,0:,0:)

	DOUBLE PRECISION partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (arr, mask=mask)

	else

		partial = SUM (arr, mask=mask)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_DOUBLE_PRECISION, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_sum_4D_D 

FUNCTION dp_product_4D_D (arr, mask) RESULT (reduction)
DOUBLE PRECISION reduction
DOUBLE PRECISION arr (0:,0:,0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:,0:,0:)

	DOUBLE PRECISION partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = PRODUCT (arr, mask=mask)

	else

		partial = PRODUCT (arr, mask=mask)


		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_DOUBLE_PRECISION, &
					MPI_PROD, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_product_4D_D 



FUNCTION dp_dot_product_4D_D (a, b) RESULT (reduction)
DOUBLE PRECISION reduction
DOUBLE PRECISION , intent(IN) :: a (0:,0:,0:,0:)
DOUBLE PRECISION , intent(IN) :: b (0:,0:,0:,0:)

	DOUBLE PRECISION partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (a*b)

	else

		partial = SUM (a*b)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_DOUBLE_PRECISION, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_dot_product_4D_D 








!		module procedure dp_sum_1D_C 
!		module procedure dp_product_1D_C 
!		module procedure dp_dot_product_1D_C 

!		public dp_sum_1D_C 
!		public dp_product_1D_C 
!		public dp_dot_product_1D_C 

FUNCTION dp_sum_1D_C (arr, mask) RESULT (reduction)
COMPLEX reduction
COMPLEX arr (0:)
logical, intent(IN), OPTIONAL :: mask (0:)

	COMPLEX partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (arr, mask=mask)

	else

		partial = SUM (arr, mask=mask)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_COMPLEX, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_sum_1D_C 

FUNCTION dp_product_1D_C (arr, mask) RESULT (reduction)
COMPLEX reduction
COMPLEX arr (0:)
logical, intent(IN), OPTIONAL :: mask (0:)

	COMPLEX partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = PRODUCT (arr, mask=mask)

	else

		partial = PRODUCT (arr, mask=mask)


		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_COMPLEX, &
					MPI_PROD, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_product_1D_C 



FUNCTION dp_dot_product_1D_C (a, b) RESULT (reduction)
COMPLEX reduction
COMPLEX , intent(IN) :: a (0:)
COMPLEX , intent(IN) :: b (0:)

	COMPLEX partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM(CONJG(a)*b)

	else

		partial = SUM(CONJG(a)*b)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_COMPLEX, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_dot_product_1D_C 








!		module procedure dp_sum_2D_C 
!		module procedure dp_product_2D_C 
!		module procedure dp_dot_product_2D_C 

!		public dp_sum_2D_C 
!		public dp_product_2D_C 
!		public dp_dot_product_2D_C 

FUNCTION dp_sum_2D_C (arr, mask) RESULT (reduction)
COMPLEX reduction
COMPLEX arr (0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:)

	COMPLEX partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (arr, mask=mask)

	else

		partial = SUM (arr, mask=mask)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_COMPLEX, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_sum_2D_C 

FUNCTION dp_product_2D_C (arr, mask) RESULT (reduction)
COMPLEX reduction
COMPLEX arr (0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:)

	COMPLEX partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = PRODUCT (arr, mask=mask)

	else

		partial = PRODUCT (arr, mask=mask)


		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_COMPLEX, &
					MPI_PROD, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_product_2D_C 



FUNCTION dp_dot_product_2D_C (a, b) RESULT (reduction)
COMPLEX reduction
COMPLEX , intent(IN) :: a (0:,0:)
COMPLEX , intent(IN) :: b (0:,0:)

	COMPLEX partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM(CONJG(a)*b)

	else

		partial = SUM(CONJG(a)*b)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_COMPLEX, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_dot_product_2D_C 








!		module procedure dp_sum_3D_C 
!		module procedure dp_product_3D_C 
!		module procedure dp_dot_product_3D_C 

!		public dp_sum_3D_C 
!		public dp_product_3D_C 
!		public dp_dot_product_3D_C 

FUNCTION dp_sum_3D_C (arr, mask) RESULT (reduction)
COMPLEX reduction
COMPLEX arr (0:,0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:,0:)

	COMPLEX partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (arr, mask=mask)

	else

		partial = SUM (arr, mask=mask)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_COMPLEX, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_sum_3D_C 

FUNCTION dp_product_3D_C (arr, mask) RESULT (reduction)
COMPLEX reduction
COMPLEX arr (0:,0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:,0:)

	COMPLEX partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = PRODUCT (arr, mask=mask)

	else

		partial = PRODUCT (arr, mask=mask)


		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_COMPLEX, &
					MPI_PROD, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_product_3D_C 



FUNCTION dp_dot_product_3D_C (a, b) RESULT (reduction)
COMPLEX reduction
COMPLEX , intent(IN) :: a (0:,0:,0:)
COMPLEX , intent(IN) :: b (0:,0:,0:)

	COMPLEX partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM(CONJG(a)*b)

	else

		partial = SUM(CONJG(a)*b)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_COMPLEX, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_dot_product_3D_C 








!		module procedure dp_sum_4D_C 
!		module procedure dp_product_4D_C 
!		module procedure dp_dot_product_4D_C 

!		public dp_sum_4D_C 
!		public dp_product_4D_C 
!		public dp_dot_product_4D_C 

FUNCTION dp_sum_4D_C (arr, mask) RESULT (reduction)
COMPLEX reduction
COMPLEX arr (0:,0:,0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:,0:,0:)

	COMPLEX partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (arr, mask=mask)

	else

		partial = SUM (arr, mask=mask)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_COMPLEX, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_sum_4D_C 

FUNCTION dp_product_4D_C (arr, mask) RESULT (reduction)
COMPLEX reduction
COMPLEX arr (0:,0:,0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:,0:,0:)

	COMPLEX partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = PRODUCT (arr, mask=mask)

	else

		partial = PRODUCT (arr, mask=mask)


		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_COMPLEX, &
					MPI_PROD, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_product_4D_C 



FUNCTION dp_dot_product_4D_C (a, b) RESULT (reduction)
COMPLEX reduction
COMPLEX , intent(IN) :: a (0:,0:,0:,0:)
COMPLEX , intent(IN) :: b (0:,0:,0:,0:)

	COMPLEX partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM(CONJG(a)*b)

	else

		partial = SUM(CONJG(a)*b)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_COMPLEX, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_dot_product_4D_C 








!		module procedure dp_sum_1D_I 
!		module procedure dp_product_1D_I 
!		module procedure dp_dot_product_1D_I 

!		public dp_sum_1D_I 
!		public dp_product_1D_I 
!		public dp_dot_product_1D_I 

FUNCTION dp_sum_1D_I (arr, mask) RESULT (reduction)
INTEGER reduction
INTEGER arr (0:)
logical, intent(IN), OPTIONAL :: mask (0:)

	INTEGER partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (arr, mask=mask)

	else

		partial = SUM (arr, mask=mask)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_INTEGER, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_sum_1D_I 

FUNCTION dp_product_1D_I (arr, mask) RESULT (reduction)
INTEGER reduction
INTEGER arr (0:)
logical, intent(IN), OPTIONAL :: mask (0:)

	INTEGER partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = PRODUCT (arr, mask=mask)

	else

		partial = PRODUCT (arr, mask=mask)


		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_INTEGER, &
					MPI_PROD, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_product_1D_I 



FUNCTION dp_dot_product_1D_I (a, b) RESULT (reduction)
INTEGER reduction
INTEGER , intent(IN) :: a (0:)
INTEGER , intent(IN) :: b (0:)

	INTEGER partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (a*b)

	else

		partial = SUM (a*b)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_INTEGER, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_dot_product_1D_I 








!		module procedure dp_sum_2D_I 
!		module procedure dp_product_2D_I 
!		module procedure dp_dot_product_2D_I 

!		public dp_sum_2D_I 
!		public dp_product_2D_I 
!		public dp_dot_product_2D_I 

FUNCTION dp_sum_2D_I (arr, mask) RESULT (reduction)
INTEGER reduction
INTEGER arr (0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:)

	INTEGER partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (arr, mask=mask)

	else

		partial = SUM (arr, mask=mask)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_INTEGER, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_sum_2D_I 

FUNCTION dp_product_2D_I (arr, mask) RESULT (reduction)
INTEGER reduction
INTEGER arr (0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:)

	INTEGER partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = PRODUCT (arr, mask=mask)

	else

		partial = PRODUCT (arr, mask=mask)


		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_INTEGER, &
					MPI_PROD, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_product_2D_I 



FUNCTION dp_dot_product_2D_I (a, b) RESULT (reduction)
INTEGER reduction
INTEGER , intent(IN) :: a (0:,0:)
INTEGER , intent(IN) :: b (0:,0:)

	INTEGER partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (a*b)

	else

		partial = SUM (a*b)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_INTEGER, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_dot_product_2D_I 








!		module procedure dp_sum_3D_I 
!		module procedure dp_product_3D_I 
!		module procedure dp_dot_product_3D_I 

!		public dp_sum_3D_I 
!		public dp_product_3D_I 
!		public dp_dot_product_3D_I 

FUNCTION dp_sum_3D_I (arr, mask) RESULT (reduction)
INTEGER reduction
INTEGER arr (0:,0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:,0:)

	INTEGER partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (arr, mask=mask)

	else

		partial = SUM (arr, mask=mask)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_INTEGER, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_sum_3D_I 

FUNCTION dp_product_3D_I (arr, mask) RESULT (reduction)
INTEGER reduction
INTEGER arr (0:,0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:,0:)

	INTEGER partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = PRODUCT (arr, mask=mask)

	else

		partial = PRODUCT (arr, mask=mask)


		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_INTEGER, &
					MPI_PROD, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_product_3D_I 



FUNCTION dp_dot_product_3D_I (a, b) RESULT (reduction)
INTEGER reduction
INTEGER , intent(IN) :: a (0:,0:,0:)
INTEGER , intent(IN) :: b (0:,0:,0:)

	INTEGER partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (a*b)

	else

		partial = SUM (a*b)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_INTEGER, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_dot_product_3D_I 








!		module procedure dp_sum_4D_I 
!		module procedure dp_product_4D_I 
!		module procedure dp_dot_product_4D_I 

!		public dp_sum_4D_I 
!		public dp_product_4D_I 
!		public dp_dot_product_4D_I 

FUNCTION dp_sum_4D_I (arr, mask) RESULT (reduction)
INTEGER reduction
INTEGER arr (0:,0:,0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:,0:,0:)

	INTEGER partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (arr, mask=mask)

	else

		partial = SUM (arr, mask=mask)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_INTEGER, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_sum_4D_I 

FUNCTION dp_product_4D_I (arr, mask) RESULT (reduction)
INTEGER reduction
INTEGER arr (0:,0:,0:,0:)
logical, intent(IN), OPTIONAL :: mask (0:,0:,0:,0:)

	INTEGER partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = PRODUCT (arr, mask=mask)

	else

		partial = PRODUCT (arr, mask=mask)


		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_INTEGER, &
					MPI_PROD, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_product_4D_I 



FUNCTION dp_dot_product_4D_I (a, b) RESULT (reduction)
INTEGER reduction
INTEGER , intent(IN) :: a (0:,0:,0:,0:)
INTEGER , intent(IN) :: b (0:,0:,0:,0:)

	INTEGER partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = SUM (a*b)

	else

		partial = SUM (a*b)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_INTEGER, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_dot_product_4D_I 


