
!		module procedure dp_all_1D 
!		module procedure dp_any_1D 
!		module procedure dp_count_1D 

!		public dp_all_1D 
!		public dp_any_1D 
!		public dp_count_1D 


FUNCTION dp_all_1D (arr) RESULT (reduction)
logical reduction
logical arr (0:)

	logical partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = all (arr)

	else

		partial = all (arr)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_LOGICAL, &
					MPI_LAND, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_all_1D 


FUNCTION dp_any_1D (arr) RESULT (reduction)
logical reduction
logical arr (0:)

	logical partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = any (arr)

	else

		partial = any (arr)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_LOGICAL, &
					MPI_LOR, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_any_1D



FUNCTION dp_count_1D (arr) RESULT (reduction)
integer reduction
logical arr (0:)

	integer partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = count (arr)

	else

		partial = count (arr)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_INTEGER, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_count_1D




!		module procedure dp_all_2D 
!		module procedure dp_any_2D 
!		module procedure dp_count_2D 

!		public dp_all_2D 
!		public dp_any_2D 
!		public dp_count_2D 


FUNCTION dp_all_2D (arr) RESULT (reduction)
logical reduction
logical arr (0:,0:)

	logical partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = all (arr)

	else

		partial = all (arr)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_LOGICAL, &
					MPI_LAND, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_all_2D 


FUNCTION dp_any_2D (arr) RESULT (reduction)
logical reduction
logical arr (0:,0:)

	logical partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = any (arr)

	else

		partial = any (arr)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_LOGICAL, &
					MPI_LOR, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_any_2D



FUNCTION dp_count_2D (arr) RESULT (reduction)
integer reduction
logical arr (0:,0:)

	integer partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = count (arr)

	else

		partial = count (arr)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_INTEGER, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_count_2D




!		module procedure dp_all_3D 
!		module procedure dp_any_3D 
!		module procedure dp_count_3D 

!		public dp_all_3D 
!		public dp_any_3D 
!		public dp_count_3D 


FUNCTION dp_all_3D (arr) RESULT (reduction)
logical reduction
logical arr (0:,0:,0:)

	logical partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = all (arr)

	else

		partial = all (arr)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_LOGICAL, &
					MPI_LAND, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_all_3D 


FUNCTION dp_any_3D (arr) RESULT (reduction)
logical reduction
logical arr (0:,0:,0:)

	logical partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = any (arr)

	else

		partial = any (arr)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_LOGICAL, &
					MPI_LOR, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_any_3D



FUNCTION dp_count_3D (arr) RESULT (reduction)
integer reduction
logical arr (0:,0:,0:)

	integer partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = count (arr)

	else

		partial = count (arr)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_INTEGER, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_count_3D




!		module procedure dp_all_4D 
!		module procedure dp_any_4D 
!		module procedure dp_count_4D 

!		public dp_all_4D 
!		public dp_any_4D 
!		public dp_count_4D 


FUNCTION dp_all_4D (arr) RESULT (reduction)
logical reduction
logical arr (0:,0:,0:,0:)

	logical partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = all (arr)

	else

		partial = all (arr)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_LOGICAL, &
					MPI_LAND, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_all_4D 


FUNCTION dp_any_4D (arr) RESULT (reduction)
logical reduction
logical arr (0:,0:,0:,0:)

	logical partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = any (arr)

	else

		partial = any (arr)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_LOGICAL, &
					MPI_LOR, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_any_4D



FUNCTION dp_count_4D (arr) RESULT (reduction)
integer reduction
logical arr (0:,0:,0:,0:)

	integer partial, complete
	integer ierr

	if (dp_num_procs .eq. 1) then

		reduction = count (arr)

	else

		partial = count (arr)

		call MPI_ALLREDUCE (partial, complete, 1, &
					MPI_INTEGER, &
					MPI_SUM, dp_comm_cart, ierr)
		! should check ierr

		reduction = complete
	endif

END FUNCTION dp_count_4D



